﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Collections.Specialized;

namespace SilverlightTable
{
    public partial class Page : UserControl
    {
        SortableCollectionView _rows = new SortableCollectionView();

        private static readonly string[] s_names = new string[] { "Frank", "Bob", "Emily", "Sam", "Wilbur" };

        private static readonly string[] s_surnames = new string[] { "Smith", "Bloggs", "McArthur", "Dingle", "Scott" };

        public Page()
        {
            InitializeComponent();

            // generate some dummy data
            Random rand = new Random();
            for (int i = 0; i < 200; i++)
            {
                Row row = new Row();
                row["Forename"] = s_names[rand.Next(s_names.Length)];
                row["Surname"] = s_surnames[rand.Next(s_surnames.Length)];
                row["Age"] = rand.Next(40) + 10;
                row["Shoesize"] = rand.Next(10) + 5;
                _rows.Add(row);
            }

            // bind to our DataGrid
            _dataGrid.ItemsSource = _rows;            
        }      
    }


    /// <summary>
    /// Represents a dynamic row of data
    /// </summary>
    public class Row 
    {
        private Dictionary<string, object> _data = new Dictionary<string, object>();

        public object this [string index]
        {
            get
            {
                return _data[index];
            }
            set
            {
                _data[index] = value;
            }
        }
    }
}
